unit hiAdjustControls;

interface

uses Windows,Kol,Share,Debug,Win;

const
  StrParam = 'left'      + #13#10 +
             'top'       + #13#10 +
             'width'     + #13#10 +
             'height'    + #13#10 +
             'align'     + #13#10 +
             'color'     + #13#10 +
             'text'      + #13#10 +
             'caption'   + #13#10 +
             'visible'   + #13#10 +
             'enabled'   + #13#10 +
             'checked'   + #13#10 +
             'selected'  + #13#10 +
             'select'    + #13#10 +
             'fontname'  + #13#10 +
             'fontcolor' + #13#10 +
             'fontsize'  + #13#10 +
             'fontstyle' + #13#10 +
             'cursor';  

type
  THIAdjustControls = class(TDebug)
   private
    FListSet,
    FListPar: PStrList;
    procedure SetText(const Value:string);
   public
    _data_Parameters:THI_Event;
    _event_onSet: THI_Event;
    
    constructor Create;
    destructor Destroy; override;
    procedure _work_doSet(var _Data: TData; Index: word);
    property _prop_Parameters: string write SetText;
  end;
    
implementation

uses hiStr_Enum;

constructor THIAdjustControls.Create;
begin
   inherited Create;
   FListSet := NewStrList;
   FListPar := NewStrList;
   FListPar.SetText(StrParam, false);
end;

destructor THIAdjustControls.Destroy;
begin
   FListSet.Free;
   FListPar.Free;
   inherited;
end;

procedure THIAdjustControls.SetText;
begin
   FListSet.SetText(Value, false);
end;

procedure THIAdjustControls._work_doSet;
var
  tmpControl: PControl;
  i, j, val: integer;
  str, s_name, s_prop: string;

   procedure change(ind: integer);
   var
     k: integer;
   begin
     with tmpControl{$ifndef F_P}^{$endif} do
     case ind of
       0: Left := str2int(str);
       1: Top := str2int(str);
       2: Width := str2int(str);
       3: Height := str2int(str);
       4: begin
            if (str ='none')  or (str ='0') then Align := caNone   else
            if (str ='left')  or (str ='1') then Align := caLeft   else
            if (str ='top')   or (str ='2') then Align := caTop    else         
            if (str ='rigth') or (str ='3') then Align := caRight  else 
            if (str ='bottom')or (str ='4') then Align := caBottom else 
            if (str ='client')or (str ='5') then Align := caClient; 
            Invalidate;
          end;
       5: Color := str2int(str); 
     6,7: Text := str; // text = caption
       8: Visible := boolean(ord(str2int(str)));
       9: Enabled := boolean(ord(str2int(str)));
   10,11: Checked := boolean(ord(str2int(str)));
      12: begin // select -  
            val := str2int(str);
            if (val < 0) or (val >= Count) then val := -1;
            CurIndex := val;
          end;
      13: Font.FontName := str;
      14: Font.Color := str2int(str);
      15: Font.FontHeight := str2int(str);
      16: begin
            Font.FontStyle := [];
            for k := 1 to length(str) do
            begin
              if str[k] = 'b' then Font.FontStyle := Font.FontStyle + [fsBold]
              else if str[k] = 'i' then Font.FontStyle := Font.FontStyle + [fsItalic]
              else if str[k] = 'u' then Font.FontStyle := Font.FontStyle + [fsUnderline]
              else if str[k] = 's' then Font.FontStyle := Font.FontStyle + [fsStrikeOut];
            end;
          end;
      17: CursorLoad(0, MakeIntResource(str2int(str)));
     end;
   end;

begin
  str := ReadString(_Data, _data_Parameters);
  if str <> '' then FListSet.SetText(str, false);
  for i := 0 to ListOfControls.Count - 1 do
  begin
    tmpControl := PControl(ListOfControls.Objects[i]);
    with tmpControl{$ifndef F_P}^{$endif}  do
    if IsControl then
    begin
      for j := 0 to FListSet.Count - 1 do
      begin
        str := FListSet.Items[j];
        if str <> '' then
        begin
          s_name := LowerCase(fparse(str,'='));
          if (s_name = LowerCase(ListOfControls.Items[i])) or (s_name = 'all') then
          begin
           s_prop := LowerCase(fparse(str,'='));
           change(FListPar.IndexOf(s_prop));
          end;
        end;
      end;
    end;
  end;
  _hi_OnEvent(_event_onSet);
end;

end.